window.Gleam.initSearch([{"doc":"glats","title":"glats","content":"# glats\n\n[![Package Version](https://img.shields.io/hexpm/v/glats)](https://hex.pm/packages/glats)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glats/)\n\nA NATS client for Gleam. This wraps Elixir&#39;s client, [Gnat](https://hex.pm/packages/gnat).\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add glats\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/glats&gt;.\n","url":"index.html"},{"doc":"glats/message","title":"Message","content":"pub type Message {\n  Message(\n    subject: String,\n    headers: Map(String, String),\n    reply_to: Option(String),\n    body: String,\n  )\n}\n A single message that can be received from or sent to NATS.\nMessage(\n  subject: String,\n  headers: Map(String, String),\n  reply_to: Option(String),\n  body: String,\n)\n\n\nSynonyms:\nglats/message.Message\nglats/message Message","url":"glats/message.html#Message"},{"doc":"glats/message","title":"new_message","content":"pub fn new_message(subject: String, message: String) -&gt; Message\n Constructs a new message.\nSynonyms:\nglats/message.new_message\nglats/message new_message","url":"glats/message.html#new_message"},{"doc":"glats/message","title":"glats/message","content":"","url":"glats/message.html"},{"doc":"glats/connection","title":"Command","content":"pub opaque type Command\n Command to send to the connection actor.\n\nSynonyms:\nglats/connection.Command\nglats/connection Command","url":"glats/connection.html#Command"},{"doc":"glats/connection","title":"ServerError","content":"pub type ServerError {\n  Timeout\n  NoResponders\n  Unknown\n}\n Error returned by a NATS server.\nTimeout\n\n\nNoResponders\n\n\nUnknown\n\n\nSynonyms:\nglats/connection.ServerError\nglats/connection ServerError","url":"glats/connection.html#ServerError"},{"doc":"glats/connection","title":"Settings","content":"pub type Settings {\n  Settings(\n    host: Option(String),\n    port: Option(Int),\n    tls: Option(Bool),\n    ssl_opts: Option(Map(String, String)),\n  )\n}\n Connection settings for NATS connection.\nSettings(\n  host: Option(String),\n  port: Option(Int),\n  tls: Option(Bool),\n  ssl_opts: Option(Map(String, String)),\n)\n\n\nSynonyms:\nglats/connection.Settings\nglats/connection Settings","url":"glats/connection.html#Settings"},{"doc":"glats/connection","title":"publish","content":"pub fn publish(conn: Subject(Command), subject: String, message: String) -&gt; Result(\n  Nil,\n  String,\n)\n Publishes a single message to NATS on a provided subject.\nSynonyms:\nglats/connection.publish\nglats/connection publish","url":"glats/connection.html#publish"},{"doc":"glats/connection","title":"publish_message","content":"pub fn publish_message(conn: Subject(Command), message: Message) -&gt; Result(\n  Nil,\n  String,\n)\n Publishes a single message to NATS using the data from a provided `Message`\n record.\nSynonyms:\nglats/connection.publish_message\nglats/connection publish_message","url":"glats/connection.html#publish_message"},{"doc":"glats/connection","title":"request","content":"pub fn request(conn: Subject(Command), subject: String, message: String) -&gt; Result(\n  Message,\n  ServerError,\n)\n Sends a request and listens for a response synchronously.\nSynonyms:\nglats/connection.request\nglats/connection request","url":"glats/connection.html#request"},{"doc":"glats/connection","title":"start","content":"pub fn start(settings: Settings) -&gt; Result(\n  Subject(Command),\n  StartError,\n)\n Start an actor that handles a connection to NATS using\n the provided settings.\nSynonyms:\nglats/connection.start\nglats/connection start","url":"glats/connection.html#start"},{"doc":"glats/connection","title":"subscribe","content":"pub fn subscribe(conn: Subject(Command), receiver: Subject(\n    Dynamic,\n  ), subject: String) -&gt; Result(String, String)\n\nSynonyms:\nglats/connection.subscribe\nglats/connection subscribe","url":"glats/connection.html#subscribe"},{"doc":"glats/connection","title":"glats/connection","content":"","url":"glats/connection.html"},{"doc":"glats/handler","title":"MessageHandler","content":"pub type MessageHandler =\n  fn(Message, Subject(Command)) -&gt; Result(Nil, String)\n Callback handler that should be provided to handle_subscription to process\n the received messages from a subscription.\n\nSynonyms:\nglats/handler.MessageHandler\nglats/handler MessageHandler","url":"glats/handler.html#MessageHandler"},{"doc":"glats/handler","title":"Request","content":"pub type Request {\n  Request(headers: Map(String, String), body: String)\n}\n Request includes headers and body from a request message.\nRequest(headers: Map(String, String), body: String)\n\n\nSynonyms:\nglats/handler.Request\nglats/handler Request","url":"glats/handler.html#Request"},{"doc":"glats/handler","title":"RequestHandler","content":"pub type RequestHandler =\n  fn(Request, Subject(Command)) -&gt; Result(Response, String)\n Callback handler that should be provided to handle_request to process the\n the received request and return a response.\n\nSynonyms:\nglats/handler.RequestHandler\nglats/handler RequestHandler","url":"glats/handler.html#RequestHandler"},{"doc":"glats/handler","title":"Response","content":"pub type Response {\n  Response(headers: Map(String, String), body: String)\n}\n Response includes headers and body for a response to a request.\nResponse(headers: Map(String, String), body: String)\n\n\nSynonyms:\nglats/handler.Response\nglats/handler Response","url":"glats/handler.html#Response"},{"doc":"glats/handler","title":"handle_request","content":"pub fn handle_request(conn: Subject(Command), subject: String, handler: fn(\n    Request,\n    Subject(Command),\n  ) -&gt; Result(Response, String)) -&gt; Result(\n  Subject(Message),\n  StartError,\n)\n Starts an actor that will handle received requests on a NATS subject and\n handle responding to them with what&#39;s returned from the provided handler.\nSynonyms:\nglats/handler.handle_request\nglats/handler handle_request","url":"glats/handler.html#handle_request"},{"doc":"glats/handler","title":"handle_subscription","content":"pub fn handle_subscription(conn: Subject(Command), subject: String, handler: fn(\n    Message,\n    Subject(Command),\n  ) -&gt; Result(Nil, String)) -&gt; Result(\n  Subject(Message),\n  StartError,\n)\n Starts an actor that will handle receiving messages from a NATS subject and\n call your handler.\nSynonyms:\nglats/handler.handle_subscription\nglats/handler handle_subscription","url":"glats/handler.html#handle_subscription"},{"doc":"glats/handler","title":"glats/handler","content":" This module provides a subscription handler that can be used\n to subscribe to NATS subjects and receive them in your own\n handler.","url":"glats/handler.html"},{"doc":"glats","title":"Message","content":"pub type Message =\n  message.Message\n\n\nSynonyms:\nglats.Message\nglats Message","url":"glats.html#Message"},{"doc":"glats","title":"MessageHandler","content":"pub type MessageHandler =\n  handler.MessageHandler\n\n\nSynonyms:\nglats.MessageHandler\nglats MessageHandler","url":"glats.html#MessageHandler"},{"doc":"glats","title":"Request","content":"pub type Request =\n  handler.Request\n\n\nSynonyms:\nglats.Request\nglats Request","url":"glats.html#Request"},{"doc":"glats","title":"RequestHandler","content":"pub type RequestHandler =\n  handler.RequestHandler\n\n\nSynonyms:\nglats.RequestHandler\nglats RequestHandler","url":"glats.html#RequestHandler"},{"doc":"glats","title":"Response","content":"pub type Response =\n  handler.Response\n\n\nSynonyms:\nglats.Response\nglats Response","url":"glats.html#Response"},{"doc":"glats","title":"connect","content":"pub fn connect(settings: Settings) -&gt; Result(\n  Subject(Command),\n  StartError,\n)\n Starts an actor that handles a connection to NATS using the provided\n settings.\nSynonyms:\nglats.connect\nglats connect","url":"glats.html#connect"},{"doc":"glats","title":"default_settings","content":"pub fn default_settings() -&gt; Settings\n Returns settings with `localhost:4222`.\n\n Use builder functions `with_*` to add additional options.\n\n \n default_settings()\n |&gt; with_port(6222)\n |&gt; with_ca(&quot;/tmp/ca.crt&quot;)\n \nSynonyms:\nglats.default_settings\nglats default_settings","url":"glats.html#default_settings"},{"doc":"glats","title":"handle_request","content":"pub fn handle_request(conn: Subject(Command), subject: String, handler: fn(\n    Request,\n    Subject(Command),\n  ) -&gt; Result(Response, String)) -&gt; Result(\n  Subject(Message),\n  StartError,\n)\n Start a request handler that will call the passed in handler\n for every message received on the provided subject and automatically\n respond with the response returned by the handler.\n\n \n pub fn main() {\n   new_settings(&quot;localhost&quot;, 4222)\n   |&gt; connect\n   |&gt; handle_request(&quot;some.nats.subject&quot;, req_handler)\n\n   process.sleep_forever()\n }\n\n pub fn req_handler(request: Request, conn: Subject(Command)) {\n   io.debug(request)\n\n   // Will respond with the same data as the request (ping pong).\n   Ok(Response(headers: request.headers, body: request.body))\n }\n \nSynonyms:\nglats.handle_request\nglats handle_request","url":"glats.html#handle_request"},{"doc":"glats","title":"handle_subscription","content":"pub fn handle_subscription(conn: Subject(Command), subject: String, handler: fn(\n    Message,\n    Subject(Command),\n  ) -&gt; Result(Nil, String)) -&gt; Result(\n  Subject(Message),\n  StartError,\n)\n Start a subscription handler that will call the passed in handler\n for every message received on the provided subject.\n\n \n pub fn main() {\n   new_settings(&quot;localhost&quot;, 4222)\n   |&gt; connect\n   |&gt; handle_subscription(&quot;some.nats.subject&quot;, sub_handler)\n\n   process.sleep_forever()\n }\n\n pub fn sub_handler(message: Message, conn: Subject(Command)) {\n   io.debug(message)\n\n   Ok(Nil)\n }\n \nSynonyms:\nglats.handle_subscription\nglats handle_subscription","url":"glats.html#handle_subscription"},{"doc":"glats","title":"new_settings","content":"pub fn new_settings(host: String, port: Int) -&gt; Settings\n Creates a settings with `host` and `port` set.\n\n Use builder functions `with_*` to add additional options.\n\n \n new_settings(&quot;localhost&quot;, 4222)\n |&gt; with_ca(&quot;/tmp/ca.crt&quot;)\n \nSynonyms:\nglats.new_settings\nglats new_settings","url":"glats.html#new_settings"},{"doc":"glats","title":"publish","content":"pub fn publish(conn: Subject(Command), subject: String, message: String) -&gt; Result(\n  Nil,\n  String,\n)\n Publishes a single message to NATS on a provided subject.\nSynonyms:\nglats.publish\nglats publish","url":"glats.html#publish"},{"doc":"glats","title":"publish_message","content":"pub fn publish_message(conn: Subject(Command), message: Message) -&gt; Result(\n  Nil,\n  String,\n)\n Publishes a single message to NATS using the data from a provided `Message`\n record.\nSynonyms:\nglats.publish_message\nglats publish_message","url":"glats.html#publish_message"},{"doc":"glats","title":"request","content":"pub fn request(conn: Subject(Command), subject: String, message: String) -&gt; Result(\n  Message,\n  ServerError,\n)\n Sends a request and listens for a response synchronously.\n\n See [request-reply pattern docs.](https://docs.nats.io/nats-concepts/core-nats/reqreply)\nSynonyms:\nglats.request\nglats request","url":"glats.html#request"},{"doc":"glats","title":"with_ca","content":"pub fn with_ca(old: Settings, cafile: String) -&gt; Settings\n Sets the CA file to use in connection settings.\nSynonyms:\nglats.with_ca\nglats with_ca","url":"glats.html#with_ca"},{"doc":"glats","title":"with_client_cert","content":"pub fn with_client_cert(old: Settings, certfile: String, keyfile: String) -&gt; Settings\n Sets client certificates in connection settings.\nSynonyms:\nglats.with_client_cert\nglats with_client_cert","url":"glats.html#with_client_cert"},{"doc":"glats","title":"with_host","content":"pub fn with_host(old: Settings, host: String) -&gt; Settings\n Sets the host for connection settings.\nSynonyms:\nglats.with_host\nglats with_host","url":"glats.html#with_host"},{"doc":"glats","title":"with_no_tls","content":"pub fn with_no_tls(old: Settings) -&gt; Settings\n Explicitly disables tls and resets ssl_opts for the connection settings.\nSynonyms:\nglats.with_no_tls\nglats with_no_tls","url":"glats.html#with_no_tls"},{"doc":"glats","title":"with_port","content":"pub fn with_port(old: Settings, port: Int) -&gt; Settings\n Sets the port for connection settings.\nSynonyms:\nglats.with_port\nglats with_port","url":"glats.html#with_port"},{"doc":"glats","title":"glats","content":" This module provides the most basic NATS client.\n\n ## Example\n\n ```gleam\n pub fn main() {\n   // Connect to localhost:4222\n   let assert Ok(conn) =\n     glats.new_settings(&quot;localhost&quot;, 4222)\n     |&gt; glats.connect\n\n   // Subscribe to subject &quot;some.nats.subject&quot;\n   let assert Ok(_) = conn\n     |&gt; glats.handle_subscription(&quot;some.nats.subject&quot;, handle_message)\n\n   // Publish a single message to subject &quot;some.nats.subject&quot;\n   // with body &quot;Hello worlds!&quot;\n   let assert Ok(_) = conn\n     |&gt; glats.publish(&quot;some.nats.subject&quot;, &quot;Hello world!&quot;)\n\n   // Sleep for a second to receive the message in the handler\n   process.sleep(1000)\n }\n\n pub fn handle_message(message: glats.Message, conn: process.Subject(glats.Command)) {\n   io.debug(message)\n   // Prints `Message(&quot;some.nats.subject&quot;, //erl(#{}), None, &quot;Hello world!&quot;)`\n\n   Ok(Nil)\n }\n ```","url":"glats.html"}]);